" Here is a small script that remaps the p and P normal commands such that VO
" will do what one would expect when pasting cut/copied nodes into another
" section of an outline. It will adjust the indents and not paste into the
" middle of a branch.
" Added 2011-03-01(JB): This script will now also copy an outline correctly by
" using \\y, copy to the register with \\r, cut an outline by using \\d, and
" paste from the register using \\b.
" http://www.lists.vimoutliner.org/pipermail/vimoutliner/2008-October/002366.html

map <buffer>p :<c-u>call VOput()<cr>
map <buffer>\\b :call VOputreg()<cr>
map <buffer>\\y :call VOcop()<cr>
map <buffer>\\r :call VOreg()<cr>
map <buffer>\\d :call VOcut()<cr>
map <buffer>P ]P

if exists('s:loaded')
	finish
endif
let s:loaded = 1

function! IsParent(line)
	if a:line == line("$")
		return 0
	elseif Ind(a:line) < Ind(a:line+1)
		return 1
	else
		return 0
	endif
endfunction


function! VOcop()
	let thisLine = line(".")
	if (foldclosed(thisLine) == -1) && IsParent(thisLine)
		normal! zc
		let fold_cursor = getpos(".")
		normal! yy
		let get_cursor = getpos(".")
	    call setpos('.',fold_cursor)
	    normal! zo
	    call setpos('.',get_cursor)
	else
		normal! yy
	endif
endfunction

function! VOreg()
	let thisLine = line(".")
	if (foldclosed(thisLine) == -1) && IsParent(thisLine)
		normal! zc
		let fold_cursor = getpos(".")
        normal! V"+y
		let get_cursor = getpos(".")
	    call setpos('.',fold_cursor)
	    normal! zo
	    call setpos('.',get_cursor)
	else
       normal! V"+y
	endif
endfunction

function! VOcut()
	let thisLine = line(".")
	if (foldclosed(thisLine) == -1) && IsParent(thisLine)
		normal! zc
		let fold_cursor = getpos(".")
		normal! dd
		let get_cursor = getpos(".")
	    call setpos('.',fold_cursor)
	    normal! zo
	    call setpos('.',get_cursor)
	else
		normal! dd
	endif
endfunction

function! VOput()
	let thisLine = line(".")
	if (foldclosed(thisLine) == -1) && IsParent(thisLine)
		normal! zc
		let fold_cursor = getpos(".")
		exe "normal! " . v:count1 . '"' . v:register . "]p"
		let put_cursor = getpos(".")
		call setpos('.',fold_cursor)
		normal! zo
		call setpos('.',put_cursor)
	else
		exe "normal! " . v:count1 . '"' . v:register . "]p"
	endif
endfunction


function! VOputreg()
	let thisLine = line(".")
	if (foldclosed(thisLine) == -1) && IsParent(thisLine)
		normal! zc
		let fold_cursor = getpos(".")
		normal! "+]p
		let put_cursor = getpos(".")
		call setpos('.',fold_cursor)
		normal! zo
		call setpos('.',put_cursor)
	else
		normal! "+]p
	endif
endfunction
